Package javassist.compiler.ast

# Class ASTree

java.lang.Object
javassist.compiler.ast.ASTree

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `ASTList`, `DoubleConst`, `IntConst`, `Keyword`, `Pair`, `StringL`, `Symbol`

public abstract class ASTree extends Object implements Serializable
Abstract Syntax Tree. An ASTree object represents a node of a binary tree. If the node is a leaf node, both `getLeft()` and `getRight()` returns null.

See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`ASTree()`

## Method Summary

Modifier and Type
Method
Description
`abstract void`
`accept(Visitor v)`
Is a method for the visitor pattern.
`ASTree`
`getLeft()`
`ASTree`
`getRight()`
`void`
`setLeft(ASTree _left)`
`void`
`setRight(ASTree _right)`
`String`
`toString()`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ASTree

public ASTree()

## Method Details

### getLeft

public ASTree getLeft()

### getRight

public ASTree getRight()

### setLeft

public void setLeft(ASTree _left)

### setRight

public void setRight(ASTree _right)

### accept

public abstract void accept(Visitor v) throws javassist.compiler.CompileError
Is a method for the visitor pattern. It calls `atXXX()` on the given visitor, where `XXX` is the class name of the node object.

Throws:
  `javassist.compiler.CompileError`

### toString

public String toString()

Overrides:
  `toString` in class `Object`